/*created: 20150831 modified: 20170825*/
if(typeof(ajaxRouter) == 'undefined')
	var ajaxRouter = '';

var purchaseTotal =
{
	cheapestMembership:
	{
		cost:null,
		id:null,
		type:null
	}, //holds cheapest membership information

	discount:
	{
		amount:0, //holds the returned amount of the applied discount
		autoApply:0, //holds the returned amount of the applied discount
		description:null, //holds the description of the applied discount
		eligible:[],
		item:null, //holds the table id of the item the discount is to be applied to
		type:null //holds the type of discount
	}, //holds applied discount information
	discountAmountTotal:0, //holds the total amount of the discount in dollars
	discountEligible:[], //holds a list of who is eligible to use the discount
	discountsAutoApply:[], //holds discounts that should automatically be applied
	discountsApplied:[], //holds a list of discounts that have been applied

	membership:[
	{
		cost:null,
		id:null,
		type:null
	}], //holds portal user information

	membershipRequestSent:false, //flag indicating if membership information has been sent for
	membershipRequestCallbackQue:[], //list of callbacks that need to execute upon the return of the request

	submitEnableFlags:
	{
		payment:true,
		portal:true
	} //flags to indicate if submit button should be enabled or disabled
};

var visitor =
{
	type:null //the type of visitor
}; //information about the visitor

purchaseTotal.updateTotal = function()
{
	var total = 0;

	$('.subtotalInput').each(function() {
			total += Number($(this).text());
	});
	//console.log(total);
	//apply discount
	if(purchaseTotal.discountType == 'percent') //percent
		total = total * purchaseTotal.discountAmountTotal;
	else //total
		total = total - purchaseTotal.discountAmountTotal;

	document.getElementById('total').innerHTML = total.toFixed(2);
}

purchaseTotal.updateDiscountAmountDisplay = function()
{
	/**
	* - Go through the list of applied discounts
	* -- Show discount description
	* -- Show discount amount
	* - Update list of discounts on the form
	*/

	if(document.getElementById('discountApply') != null)
	{
		var ul = ''; //

		for(var i=0, len=purchaseTotal.discountsApplied.length; i<len; i++)
			ul += '<li><span>' + purchaseTotal.discountsApplied[i].description + '</span><span>' + (purchaseTotal.discountsApplied[i].type == 'total' || purchaseTotal.discountsApplied[i].type == 'item' ? '- $' + purchaseTotal.discountsApplied[i].amount : purchaseTotal.discountsApplied[i].amount + (purchaseTotal.discountsApplied[i].type == 'percent' ? '%' : '')) + '</span></li>';//.toFixed(2)

		if(ul) ul = '<ul>' + ul + '</ul>';

		document.getElementById('discountApply').innerHTML = ul;
	}

	//(typeof(document.getElementById('discountApply')) != 'undefined') && (document.getElementById('discountApply')) && (document.getElementById('discountApply').innerHTML = (purchaseTotal.discountAmountTotal ? ('-' + (purchaseTotal.discountType == 'total' || purchaseTotal.discountType == 'item' ? '$' : '') + purchaseTotal.discountAmountTotal + (purchaseTotal.discountType == 'percent' ? '%' : '')): ''));
	/*
	if(purchaseTotal.discountAmountTotal)
	{
		document.getElementById('discountApply').innerHTML = '-' + (purchaseTotal.discountType == 'total' || purchaseTotal.discountType == 'item' ? '$' : '') + purchaseTotal.discountAmountTotal + (purchaseTotal.discountType == 'percent' ? '%' : '');
	}
	else
		document.getElementById('discountApply').innerHTML = '';*/
}

purchaseTotal.applyBestDiscount = function()
{
	/**
	* Compares all eligible discounts and an applied discount to determine which one is the best
	*/
}

purchaseTotal.eligibleForDiscount = function(eligible)
{
	//console.log('eligible');
	console.log(eligible);
  console.log(visitor.type);
	console.log(eligible.indexOf(visitor.type.toString()) + 1);

	if(eligible.length < 1)
		return true
	else if(visitor.type != null)
	  return eligible.indexOf(visitor.type.toString()) + 1;

	return 0;
}

purchaseTotal.updateDiscountAmountTotal = function()
{
	/**
	* - Calculate the sum of all discounts
	* - Update purchaseTotal.discountAmountTotal
	*/

	var total = 0;

	for(var i=0, len=purchaseTotal.discountsApplied.length; i<len; i++)
	{
		//console.log(purchaseTotal.discountsApplied[i]);
		if(purchaseTotal.discountsApplied[i].type == 'item' && purchaseTotal.discountsApplied[i].item) //specific item
		{
			//console.log('itemdiscount');
			var quantity = purchaseTotal.getQuantity(purchaseTotal.discountsApplied[i].item);

			if(quantity)
				total += purchaseTotal.discountsApplied[i].amount * quantity;
		}
		else if(purchaseTotal.discountsApplied[i].type == 'percent') //percent
			total += (100 - purchaseTotal.discountsApplied[i].amount) / 100;
		else if(purchaseTotal.discountsApplied[i].type == 'total') //total
			total += purchaseTotal.discountsApplied[i].amount;
	}

	 purchaseTotal.discountAmountTotal = total;
	 //console.log(purchaseTotal.discountAmountTotal);

/*	if(purchaseTotal.discountEligible.length == 0 || purchaseTotal.portalType.indexOf(purchaseTotal.discountEligible))
	{
		if(purchaseTotal.discountType == 'item' && purchaseTotal.discountItem) //specific item
		{
			var quantity = purchaseTotal.getQuantity(purchaseTotal.discountItem);

			if(quantity)
				purchaseTotal.discountAmountTotal = purchaseTotal.discountAmount * quantity;
			else
				purchaseTotal.discountAmountTotal = 0;
		}
		else if(purchaseTotal.discountType == 'percent') //percent
			purchaseTotal.discountAmountTotal = (100 - purchaseTotal.discountAmount) / 100;
		else if(purchaseTotal.discountType == 'total') //total
			purchaseTotal.discountAmountTotal = purchaseTotal.discountAmount;
		else
			purchaseTotal.discountAmountTotal = 0;
	}*/
}

purchaseTotal.updateDiscountsApplied = function()
{
	/**
	* - Reset purchaseTotal.discountsApplied
	* - Itinerate through automatically applied discounts
	* - Evaluate applied discount
	*/

	var j = 0; //index for purchaseTotal.discountsApplied
	purchaseTotal.discountsApplied = [];
	console.log(purchaseTotal.discountsAutoApply);
	for(var i=0, len=purchaseTotal.discountsAutoApply.length; i<len; i++)
		if(purchaseTotal.eligibleForDiscount(purchaseTotal.discountsAutoApply[i].eligible))
		{
			//console.log('adding');
			//console.log(purchaseTotal.discountsAutoApply[i]);
			purchaseTotal.discountsApplied[j] = purchaseTotal.discountsAutoApply[i];
			//console.log(purchaseTotal.discountsApplied[j]);
			j++;
		}

	if(purchaseTotal.discount.amount && purchaseTotal.discount.autoApply == 0 && purchaseTotal.eligibleForDiscount(purchaseTotal.discount.eligible))
		purchaseTotal.discountsApplied[j] = purchaseTotal.discount;

	//console.log(purchaseTotal.discountsApplied);
}

purchaseTotal.getQuantity = function(fiid)
{
	//get quantity of specific item
	var quantity = document.getElementById('quantityInput' + fiid);

	if(typeof(quantity) != 'undefined')
		return quantity.value;

	return null;
}

purchaseTotal.getDiscount = function()
{
	var request = $.post(ajaxRouter, {code:document.getElementById('discountInput').value, file:'forms/forms.php', salt:document.getElementById('discountSalt').value}); //send request

	request.done(function(vars) //evaluate request
	{
		//console.log(vars);
		if(vars = vars.parseStr())
		{
		//console.log(vars);
			purchaseTotal.discount.amount = typeof(vars.amount) == 'undefined' ? 0 : Number(vars.amount);
			purchaseTotal.discount.autoApply = typeof(vars.autoApply) == 'undefined' ? 0 : Number(vars.autoApply);
			purchaseTotal.discount.description = typeof(vars.description) == 'undefined' ? '' : vars.description;
			purchaseTotal.discount.eligible = typeof(vars.eligible) == 'undefined' ? [] : vars.eligible.split('|');
			purchaseTotal.discount.item = typeof(vars.item) == 'undefined' ? null : Number(vars.item);
			purchaseTotal.discount.type = typeof(vars.type) == 'undefined' ? null : vars.type;

			purchaseTotal.updateDiscountsApplied();
			purchaseTotal.updateDiscountAmountTotal();
			purchaseTotal.updateDiscountAmountDisplay();
			purchaseTotal.updateTotal();
		}
	});
}

purchaseTotal.getDiscounts = function() //gets discounts that should automatically be applied
{
	/**
	* Gets all discounts that should automatically be applied
	* - Request returns an array of all discount information
	* - All informatio is stored in purchaseTotal.discountsAutoApply
	*/

	if(document.getElementById('discountSalt') == null)
	{
		purchaseTotal.updateTotal();
	}
	else
	{
		var request = $.post(ajaxRouter, {code:null, file:'forms/forms.php', salt:document.getElementById('discountSalt').value}); //send request

		request.done(function(vars) //evaluate request
		{
			//console.log(vars);
			if(vars = vars.parseStr())
			{
				//console.log('vars');
				//console.log(vars);
				if(typeof(vars.amount) != 'undefined')
					for(var i=0, len=vars.amount.length; i<len; i++)
					{
						//console.log('amount' + vars.amount[i]);
						purchaseTotal.discountsAutoApply[i] =
						{
							amount:vars.amount[i],
							description:vars.description[i],
							eligible:vars.eligible[i].split('|'),
							item:vars.item[i],
							type:vars.type[i]
						};
					}

				purchaseTotal.updateDiscountsApplied();
				purchaseTotal.updateDiscountAmountTotal();
				purchaseTotal.updateDiscountAmountDisplay();
				purchaseTotal.updateTotal();
				console.log('auto');
				purchaseTotal.updateJoinDiscountInformation();
			}
		});
	}
}

purchaseTotal.updateJoinDiscountInformation = function()
{
	/**
	* Checks if membership is required or if a memberhsip discount is available an words message accordingly
	*/

	var joinDiscount = null;

	//check if applicant is an eligible member
	if((joinDiscount = document.getElementById('joinDiscount')) != null)
	{
		var membership = purchaseTotal.getCheapestMembership(purchaseTotal.updateJoinDiscountInformation);

		if(membership) //get cheapest membership option
		{
			var discount = purchaseTotal.getMembershipDiscountAmount(membership.id); //check for membership discount

			if(membership)
				joinDiscount.innerHTML = 'Join for one year for only $' + membership.cost + (discount ? ' and save $' + discount + ' on this event!' : '.'); //add message to form
		}
	}
}

purchaseTotal.getCheapestMembership = function(callback)
{
	if(purchaseTotal.cheapestMembership.cost == null)
	{
		if(purchaseTotal.membership[0].cost == null)
		{
			purchaseTotal.setMembership(callback);
			return false; //have to wait for information
		}

		var cheapest = {cost:1000000, id:null}; //set to an unreasonable cost

		for(var i=0, len=purchaseTotal.membership.length; i<len; i++)
			if(purchaseTotal.membership[i].cost > 0 && purchaseTotal.membership[i].cost < cheapest.cost)
				cheapest =
				{
					cost:purchaseTotal.membership[i].cost,
					id:purchaseTotal.membership[i].id,
					type:purchaseTotal.membership[i].type
				};

		purchaseTotal.cheapestMembership = cheapest;
	}

	return purchaseTotal.cheapestMembership;
}

purchaseTotal.setMembership = function(callback)
{
	purchaseTotal.membershipRequestCallbackQue[purchaseTotal.membershipRequestCallbackQue.length] = callback;

	if(!purchaseTotal.membershipRequestSent)
	{
		purchaseTotal.membershipRequestSent = true;

		var request = $.post(ajaxRouter, {action:'getPortalUserTypesInformation', file:'modules/portal/portalAjax.php'}); //send request

		request.done(function(vars) //evaluate request
		{
			console.log(vars);
			if(vars = vars.parseStr())
			{
				//console.log('vars');
				//console.log(vars);
				if(typeof(vars.type) != 'undefined')
					for(var i=0, len=vars.type.length; i<len; i++)
					{
						purchaseTotal.membership[i] =
						{
							cost:vars.cost[i],
							id:vars.putid[i],
							type:vars.type[i]
						};
					}

				console.log(purchaseTotal.membership);

				for(var i=0, len=purchaseTotal.membershipRequestCallbackQue.length; i<len; i++)
					purchaseTotal.membershipRequestCallbackQue[i]();
			}
		});
	}
}

purchaseTotal.getMembershipDiscountAmount = function(id)
{
		console.log(purchaseTotal.discountsAutoApply);
	for(i=0, len=purchaseTotal.discountsAutoApply.length; i<len; i++)
	{
		if((purchaseTotal.discountsAutoApply[i].eligible.indexOf(id) + 1))
			return purchaseTotal.discountsAutoApply[i].amount;
	}

	return false;
}

purchaseTotal.updateJoinValue = function()
{
	var _join, cheapest;

	if((_join = document.getElementById('_' + purchaseTotal.unique + '_portal_join')) != null && (cheapest = purchaseTotal.getCheapestMembership(purchaseTotal.updateJoinValue)))
	{
		_join.value = cheapest.id;
		console.log(_join.value);
	}

	return false
}

purchaseTotal.addItem = function(item)
{
	var field = document.createElement('div');
	field.className = 'formField';
	field.id = 'formField' + item.id;
	field.innerHTML = '\
				<span><label for="_teslarace20170405150839_tshirtsmall_teslarace20170405150839">' + item.description + '</label></span><span class="costSpan"> \
					<span class="costFlex"> \
						<span class="cost" id="cost' + item.id + '">$' + item.amount + '</span> \
						<span class="operator">x</span> \
						<span class="quantity"><input class="size4 quantityInput" id="quantityInput' + item.id + '" name="quantity[]" type="text" value="' + item.quantity + '"' + (item.readonly ? ' readonly="readonly"' : '') + '><input name="eritid[]" type="hidden" value="' + item.id + '"></span> \
						<span class="operator">=</span> \
						<span class="subtotal">$<span class="subtotalInput" id="subtotal' + item.id + '">' + (item.amount * item.quantity).toFixed(2) + '</span></span></span></span>';

	document.getElementById('formItems').appendChild(field);
	//$('.costSpan')
}

purchaseTotal.removeItem = function(item)
{
	var field = document.getElementById('formField' + item.id);

	if(field != null)
	  field.parentNode.removeChild(field);
}

purchaseTotal.submitEnableToggle = function(flag, value)
{
	if(typeof(flag) != 'undefined')
		purchaseTotal.submitEnableFlags[flag] = value;

	for(var key in purchaseTotal.submitEnableFlags)
		if(!purchaseTotal.submitEnableFlags[key])
		{
			$('#' + purchaseTotal.form + ' [type=submit]').prop('disabled', true);
			return false;
		}

	$('#' + purchaseTotal.form + ' [type=submit]').prop('disabled', false);
	return true;
}

quantityAutoIncrement = function()
{
	$('.item').each(function()
	{
		if(this.type == 'text')
			$(this).on('blur', quantityUpdate);
		else if(this.type == 'checkbox')
			$(this).change(quantityUpdate);
	});

	$('.costRemove').on('mousedown', quantityUpdateAll);

	quantityUpdateAll();
}

quantityUpdate = function()
{
	/**
	* - Get class name
	* - Find which item this affects
	* - Get all elements that increment this item
	* - Sum those elements that are not empty
	* - Update remaining quantity
	* - Write sum to item quantity
	* -- Quantity will be recalculated after form submission to prevent tampering
	* - Update purchase totals
	*/

	var classes = this.className.split(' ');

	for(i=0, len=classes.length; i<len; i++)
		if(classes[i].match(/^item(\d+)/))
		{
			var itemId = classes[i].replace(/[\D]/g, '');
			var quantity = 0;

			$('.' + classes[i]).each(function()
			{
				if((this.type == 'text' && this.value.replace(/\s/g,'').length) || (this.type == 'checkbox' && this.checked))
					quantity++;
			});

			items.remaining.update(itemId, quantity);
			document.getElementById('quantityDisplay' + itemId).innerHTML = document.getElementById('quantityInput' + itemId).value = quantity;

			document.getElementById('subtotal' + itemId).innerHTML = (quantity * document.getElementById('cost' + itemId).innerHTML.replace(/[^\d\.]/g, '')).toFixed(2);

			purchaseTotal.updateDiscountsApplied();
			purchaseTotal.updateDiscountAmountTotal();
			purchaseTotal.updateDiscountAmountDisplay();
			purchaseTotal.updateTotal();
		}

}

quantityUpdateAll = function()
{
	$('.item').each(function()
	{
		if(this.type == 'text')
			$(this).trigger('blur');
		else if(this.type == 'checkbox')
			$(this).trigger('change');
	});
}

visitor.getType = function()
{
	var request = $.post(ajaxRouter, {action:'getVisitorType', file:'forms/forms.php'}); //send request

	request.done(function(vars) //evaluate request
	{
		console.log(vars);
		if(vars = vars.parseStr())
		{
			if(typeof(vars.type) != 'undefined')
				visitor.type = vars.type;
		}

		purchaseTotal.getDiscounts(); //get discounts that should automatically be applied; must be here else it may be done before visitor type is fetched
	});
}

var items = {remaining: {}};

items.remaining.set = function() //sets javascript varibles to keep track of remaining items
{
	items.remainingList = [];

	$('.itemsRemaining').each(function()
	{
		var classes = this.className.split(' ');

		for(i=0, len=classes.length; i<len; i++)
			if(classes[i].match(/^itemsRemaining(\d+)/))
			{
				items.remainingList[classes[i].replace(/[\D]/g, '')] = this.innerHTML.replace(/[\D]/g, '');

				if(this.innerHTML.replace(/[\D]/g, '') > 0)
				  items.enable(classes[i].replace(/[\D]/g, ''));
				else
				  items.disable(classes[i].replace(/[\D]/g, ''));

			}
	});
}

items.remaining.update = function(itemId, quantity) //updates the number of remaining items
{
	if(typeof(items.remainingList[itemId]) != 'undefined')
	{
		//need to determine whether to increment or decrement
		var remaining = items.remainingList[itemId] - quantity;

		if(remaining > 0)
		{
			$('.itemsRemaining' + itemId).html('Only ' + remaining + ' Remaining');
			items.enable(itemId);
			//console.log('not sold');
		}
		else
		{
			$('.itemsRemaining' + itemId).html('Sold Out');
			items.disable(itemId);
			//console.log('sold');
		}
	}
}

items.disable = function(itemId) //disable a form field that auto increments
{
	//console.log('here');
	$('.item' + itemId).prop('disabled', true);
}

items.enable = function(itemId) //enable a form field that auto increments
{
	$('.item' + itemId).prop('disabled', false);
}

loginSuccessful = function(user)
{
	visitor.type = user.type;
	document.getElementById('joinLoginFields').style.display = 'none';
	purchaseTotal.updateDiscountsApplied();
	purchaseTotal.updateDiscountAmountTotal();
	purchaseTotal.updateDiscountAmountDisplay();
	purchaseTotal.updateTotal();
	$.colorbox.close();
}

$(document).ready(function()
{
  if(document.getElementById('formUnique') != null)
  	purchaseTotal.unique = document.getElementById('formUnique').value;

	//for login
	if(document.getElementById('portalUserLogin') != null)
		document.getElementById('portalUserLogin').href = '/red/modules/portal/userLoginForm.php';

	$('#portalUserLogin').colorbox({
		closeButton: true,
		fixed:true,
		height:'300px',
		width:($(window).width() > 400 ? '400px' :  '100%'),
		iframe:true,
		overlayClose:false
	});

	//for uploading images
	$('.imageUploadCrop').colorbox({
		closeButton: true,
		height: $(window).height()*.75,
		width: $(window).width()*.75,
		iframe:true,
		overlayClose:false,
		onClosed:function()
		{
			//console.log(window);
			//console.log(imageUploadCropUnique);
			if(typeof imageUploadCropUrl != 'undefined')
			{
				if(document.getElementById('imagePreview' + imageUploadCropUnique) != null)
					document.getElementById('imagePreview' + imageUploadCropUnique).src = '/' + imageUploadCropUrl;
				else //add element
				{
					$('#imageUploadCrop' + imageUploadCropUnique).before($('<img />').attr(
					{
						class:'imagePreview',
						id:'imagePreview' + imageUploadCropUnique,
						src:'/' + imageUploadCropUrl
					}));

					$('#imageUploadCrop' + imageUploadCropUnique).html('Change Image');
				}

				document.getElementById('image' + imageUploadCropUnique).value = imageUploadCropUrl;
				imageUploadCropUrl = undefined;
				imageUploadCropUnique = undefined;
			}
		}
	});

	//for portal
	if(document.getElementsByClassName('costSpan').length)
	{
		purchaseTotal.form = document.getElementById('formUnique').value;

		purchaseTotal.submitEnableToggle; // $('#' + purchaseTotal.form + ' [type=submit]').prop('disabled', true);
		$('#' + purchaseTotal.form + ' #_' + purchaseTotal.form + '_portal_join').on('change', function()
		{
			//console.log(purchaseTotal.form + 'non' + this.checked);
			if(this.checked)
			{
				purchaseTotal.addItem(
				{
					amount:purchaseTotal.getCheapestMembership().cost,
					description:purchaseTotal.getCheapestMembership().type + ' Fee',
					name:'',
					quantity:1,
					readonly:true,
					id:'membershipFee',
				}); //add mebership fee

				visitor.typeSave = visitor.type; //remember old type
				visitor.type = purchaseTotal.getCheapestMembership().id; //set new type
				purchaseTotal.submitEnableToggle('portal', true);
			}
			else
			{
				purchaseTotal.removeItem(
				{
					id:'membershipFee',
				}); //remove mebership fee

				visitor.type = visitor.typeSave; //restore old type
				purchaseTotal.submitEnableToggle('portal', false);
			}

			//update form
			purchaseTotal.updateDiscountsApplied();
			purchaseTotal.updateDiscountAmountTotal();
			purchaseTotal.updateDiscountAmountDisplay();
			purchaseTotal.updateTotal();
		});


		$('.quantityInput').on('blur', function()
		{
			var id = this.id.replace('quantityInput','');

			document.getElementById('subtotal' + id).innerHTML = (Number(this.value.replace(/[^\d\.]/g, '')).toFixed() * document.getElementById('cost' + id).innerHTML.replace(/[^\d\.]/g, '')).toFixed(2);

			purchaseTotal.updateDiscountsApplied();
			purchaseTotal.updateDiscountAmountTotal();
			purchaseTotal.updateDiscountAmountDisplay();
			purchaseTotal.updateTotal();
		});

		$('#discountButton').on('click', function()
		{
			purchaseTotal.getDiscount();
		});
	}

	//set submit flags
	if(document.getElementById('cardNumber') != null)
		purchaseTotal.submitEnableFlags.payment = false;

	if(document.getElementById('portalUserTypes') != null)
		purchaseTotal.submitEnableFlags.portal = false;

	//initialize
	if(true)
	{
		//visitor.getType();
		//items.remaining.set();
		quantityAutoIncrement(); //must come after items are set
		//purchaseTotal.updateJoinValue();
		console.log('loaded');
	}
});
