/**
* This script manages the functionality for archiving the supplied item.
*
* @created  20181203
* @modified 20181203
* @author   Joshua Dale
*/

var Forms =
{
  //methods
  __init:function()
  {
  },

  /**
  * This method adds one or more fields or a block of fields to a form.
  *
  * @param object properties - Properties with information for adding
  *
  * @return bool
  */

  addField:function(properties)
  {
    console.log(properties);
    //initialize properties
    var
      callback = propertyValue('callback', properties),
      fieldBlock = propertyValue('fieldBlock', properties),
      fields = propertyValue('fields', properties),
      insertAfter = propertyValue('insertAfter', properties),
      insertBefore = propertyValue('insertBefore', properties),
      idsToReplace = propertyValue('idsToReplace', properties),
      idSuffix = propertyValue('idSuffix', properties);

    //initialize variables
    var
      i = 0,
      len = 0;

    //initialize idSuffix
    idSuffix =
    {
      old:propertyValue('old', idSuffix, ''),
      new:propertyValue('new', idSuffix, Math.floor(Math.random() * 1000) + 100) //random number between 100 and 1100
    }
console.log(fieldBlock);

    //clone
    if(fieldBlock != null) //clone block
      fieldBlock = $(fieldBlock).clone();
    else if(fields != null) //clone fields && !fields.isArray())
    {
      if(!Array.isArray(fields))
        fields = [fields];

      fieldBlock = $('<div></div>');

      for(i=0, len=fields.length; i<len; i++)
        fieldBlock.append(fields[i].clone(true));
    }
console.log(fieldBlock);

    if(fieldBlock)
    {
      //change ids
      if(idsToReplace != null)
      {
        if(!Array.isArray(idsToReplace))
          idsToReplace = [idsToReplace];

        for(i=0, len=idsToReplace.length; i<len; i++)
          fieldBlock.find('#'+idsToReplace[i]+idSuffix.old).prop('id', idsToReplace[i]+idSuffix.new);
      }
  console.log(fieldBlock);
  console.log(insertBefore);
      //insert
      if(insertBefore != null) //insert before
        $(insertBefore).before(fieldBlock);
      else if(insertAfter != null) //insert after
        $(insertAfter).after(fieldBlock);

      if(typeof callback == 'function')
      {
        console.log('here');
        callback();
      }
    }

  },

  removeField:function()
  {
  }
}

$(function()
{
  Forms.__init();
});
