/**
* This script manages the functionality for selecting an image using the Responsive File Manager.
*
* @created  20150831
* @modified 20170825
* @author   Joshua Dale
*/

var imageSelect =
{
  //properties
  placeholderUrl:SITE_ROOT+'images/cms/image-placeholder.png',

  //methods
  __init:function()
  {
    $('.removeImage').on('click tap', imageSelect.remove);

    $('.responsiveFileManager').colorbox(
    {
      closeButton: true,
      height: 600,
      width: 900,
      iframe:true,
      overlayClose:true
    });
  },

  update:function(fieldId)
  {
    var
      prefix = fieldId.replace('_imageNew', ''),
      remove = new RegExp(SITE_ROOT),
      //remove = new RegExp('^https?\:\/\/[a-zA-Z0-9\\.]+\\.[a-zA-Z0-9]{2,}'+SITE_ROOT),
      image = document.getElementById(prefix+'_imageNew').value;

    document.getElementById(prefix+'_imagePreview').src = image;
    document.getElementById(prefix+'_imageNew').value = image.replace(remove, '');
    document.getElementById(prefix+'_imageSelect').innerText = 'Change Image';
    $('#'+prefix+'_imageRemove').removeClass('hidden');
    $('#cboxClose').click();
  },

  remove:function(e)
  {
    e.preventDefault();

    var prefix = this.id.replace('_imageRemove', '');

    document.getElementById(prefix+'_imagePreview').src = imageSelect.placeholderUrl;
    document.getElementById(prefix+'_imageNew').value = document.getElementById(prefix+'_imageCurrent').value = '';
    document.getElementById(prefix+'_imageSelect').innerText = 'Add Image';
    $(this).addClass('hidden');
  }
}

$(function()
{
  imageSelect.__init();
});

function responsive_filemanager_callback(fieldId)
{
  imageSelect.update(fieldId);
}
