var SleepProfile =
{
  page:1,
  pages:6,
  __init:function()
  {
    SleepProfile.pages = $('#sleepProfileDiv form fieldset').length - 1;
    $('#sleepProfileDiv form').css('height', SleepProfile.getTallestFieldsetHeight()); //set form height
    $('#sleepProfileDiv fieldset').addClass('hidden'); //hide all fieldsets
    $('#sleepProfileDiv fieldset:first-of-type').removeClass('hidden'); //show first fieldset
    $('#sleepProfileNavigationPrevious').addClass('invisible'); //hide previous button
    $('#sleepProfileNavigationPrevious').on('click', SleepProfile.previous);
    $('#sleepProfileNavigationNext').on('click', SleepProfile.next);
    //$('#sleepProfileNavigation span').on('click', SleepProfile.switch);

    $('#sleepProfileDiv form .checklist li').wrapInner('<label></label>');

    //add  navigation buttons
    $('#sleepProfileNavigationPages').append('<span></span>'.repeat(SleepProfile.pages - 1));

    $(window).resize(function()
    {
      if(typeof SleepProfile.resizeTimeout != 'undefined')
        clearTimeout(SleepProfile.resizeTimeout);

      SleepProfile.resizeTimeout = setTimeout(SleepProfile.resize, 250);
    });

    setTimeout(function()
    {
      SleepProfile.resize();
    }, 500);
  },
  getTallestFieldsetHeight:function()
  {
    if(window.outerHeight > 650)
    {
      var height = 0;

      $('#sleepProfileDiv fieldset').each(function()
      {
        if($(this).outerHeight(true) > height)
          height = $(this).outerHeight(true);
      });

      return height;
    }
    else
      return 'auto';
  },
  hideFieldset:function()
  {
    $('#sleepProfileDiv fieldset:nth-of-type('+SleepProfile.page+')').addClass('hidden');
    $('#sleepProfileNavigationPages span:nth-of-type('+SleepProfile.page+')').removeClass('selected');
  },
  next:function()
  {
    SleepProfile.hideFieldset();
    SleepProfile.page++;
    SleepProfile.showFieldset();

    if(SleepProfile.page > 1) //show previous button
      $('#sleepProfileNavigationPrevious').removeClass('invisible');

    if(SleepProfile.page >= SleepProfile.pages) //change text on next button
      $('#sleepProfileNavigationNext').text('Bed Me');
    else
      $('#sleepProfileNavigationNext').text('Next');

    if(SleepProfile.page >= (SleepProfile.pages + 1))
    {
      //$('#sleep-profile-20180703140606').append('<input name="newAction" type="hidden" value="go" />');
      $('#sleep-profile-20180703140606').attr('target', 'sode');
      document.getElementById('submitSpBedMe').click();
      SleepProfile.setAction();
    }
  },
  previous:function()
  {
    SleepProfile.hideFieldset();
    SleepProfile.page--;
    SleepProfile.showFieldset();

    if(SleepProfile.page < 2) //hide previous button
      $('#sleepProfileNavigationPrevious').addClass('invisible');

    if(SleepProfile.page <= SleepProfile.pages) //change text on next button
      $('#sleepProfileNavigationNext').text('Next');
  },
  resize:function()
  {
    $('#sleepProfileDiv fieldset').removeClass('hidden'); //show all fieldsets
    $('#sleepProfileDiv form').css('height', SleepProfile.getTallestFieldsetHeight()); //set form height
    $('#sleepProfileDiv fieldset').addClass('hidden'); //hide all fieldsets
    SleepProfile.showFieldset();
  },
  setAction:function()
  {
    var
      i = 0,
      comfort = $('[name="preferredFeelSpWhatFeelDoYouPreferInAMattress"]:checked').val(),
      filter = [],
      price = $('[name="budgetSpWhatBudgetAreYouWorkingWith"]:checked').val().replace(/[^\d\-]*/g, '').split('-'),
      size = $('[name="sizeSpWhatSizeOfMattressBestSuitsYou"]:checked').val(),
      type = $('[name="preferredMattressTypeSpWhatTypeOfMattressInterestsYou"]:checked').val();

    $('[name="preferredFeelSpWhatFeelDoYouPreferInAMattress"]').each(function()
    {
      if(this.value == comfort)
      {
        switch(i)
        {
          case 0:
            filter[0] = 'filter[]=products/beds/mattresses/specification/comfort-type/ultra-plush/';
            break;
          case 1:
            filter[0] = 'filter[]=products/beds/mattresses/specification/comfort-type/plush/';
            break;
          case 2:
            filter[0] = 'filter[]=products/beds/mattresses/specification/comfort-type/firm/';
            break;
          case 3:
            filter[0] = 'filter[]=products/beds/mattresses/specification/comfort-type/extra-firm/';
            break;
        }

        return false;
      }

      i++;
    });

    i = 0;

    $('[name="preferredMattressTypeSpWhatTypeOfMattressInterestsYou"]').each(function()
    {
      if(this.value == type)
      {
        switch(i)
        {
          case 0:
            filter[1] = 'filter[]=products/beds/mattresses/specification/mattress-type/traditional/';
            break;
          case 1:
            filter[1] = 'filter[]=products/beds/mattresses/specification/mattress-type/specialty/';
            break;
          case 2:
            filter[1] = 'filter[]=products/beds/mattresses/specification/mattress-type/hybrid/';
            break;
        }

        return false;
      }

      i++;
    });

    $('[name="sizeSpWhatSizeOfMattressBestSuitsYou"]').each(function()
    {
      if(this.value == size)
      {
        switch(i)
        {
          case 0:
            filter[2] = 'filter[]=products/beds/specification/size/twin/';
            break;
          case 1:
            filter[2] = 'filter[]=products/beds/specification/size/twin-xl/';
            break;
          case 2:
            filter[2] = 'filter[]=products/beds/specification/size/full/';
            break;
          case 3:
            filter[2] = 'filter[]=products/beds/specification/size/queen/';
            break;
          case 4:
            filter[2] = 'filter[]=products/beds/specification/size/king/';
            break;
          case 5:
            filter[2] = 'filter[]=products/beds/specification/size/split-cal-king/';
            filter[3] = 'filter[]=products/beds/specification/size/cal-king/';
            break;
        }

        return false;
      }

      i++;
    });

    i = 0;


    /*
    document.getElementById('sleep-profile-20180703140606').action = SITE_ROOT+'shop/products/beds/mattresses/?'+
    filter.join('&', )+
    '&limit=3'+
    '&priceMin='+price[0]+
    '&priceMax='+price[1]+
    '&action=filter';
    */

    setTimeout(function()
    {
      window.location.href = SITE_ROOT+'shop/products/beds/mattresses/?'+
      filter.join('&', )+
      '&limit=3'+
      '&priceMin='+price[0]+
      '&priceMax='+price[1]+
      '&action=filter'+
      '&form=mattress-match-maker';
    }, 1000) ;

  },
  showFieldset:function()
  {
    $('#sleepProfileDiv fieldset:nth-of-type('+SleepProfile.page+')').removeClass('hidden');
    $('#sleepProfileNavigationPages span:nth-of-type('+SleepProfile.page+')').addClass('selected');
  },
};

$(function()
{
  SleepProfile.__init();
});
