<?php /*created: 20160101 modified: 20210512*/
/*
* This will be used for both the live and editing
*- This will combine all stylsheets into one to be served with one request
*- Need a way to include and exclude stylesheets
*/

//initialize CMS
if(!defined('CONN_LOADED'))
{
  $conn = 'private_html/'.(strpos($_SERVER['HTTP_HOST'], 'localhost') !== false ? 'conn-desktop' : 'conn-web').'.php'; //get appropriate configuration
  for($i=0, $rr = ''; !file_exists($rr.$conn) && $i<25; ++$i, $rr .= '../'); //find relative path; NOTE: Not always in the root directory!
  if($i < 25) require_once $rr.$conn; else die('Error 174: Unable to load page: Required file not found.  Please check the link and try again.'); //load configuration
  require_once CMS_SERVER_ROOT.'library/cms.class.php'; //load CMS library
}

global $Cms;

libraries(array('Format'));

\CmsC::_require('/styles/site/styles.class.php');

//page information
$id = empty($_GET['id']) ? NULL : \FormatC::number($_GET['id']);
$cid = empty($_GET['cid']) ? $id : \FormatC::number($_GET['cid']);

$alias = empty($_GET['alias']) ? NULL : preg_replace('/.html$/','',$_GET['alias']);
$directory = isset($_GET['directory']) ? $_GET['directory'] : NULL;
$secure = $directory == 'user/' ? true : false;

$styleFolder = 'styles/site/';

header ('content-type: text/css; charset: UTF-8');
//header("Last-Modified: ".gmdate('D, d M Y H:i:s', filemtime($_SERVER['DOCUMENT_ROOT'].$_SERVER['PHP_SELF']))." GMT");
//header("Expires: ".gmdate('D, d M Y H:i:s', (filemtime($_SERVER['DOCUMENT_ROOT'].$_SERVER['PHP_SELF']) + 691200))." GMT");

ob_start(function($css)
{
	return $css;
	return \FormatC::minifyCss($css);
});

if(file_exists(SERVER_ROOT.$styleFolder.'site-styles-configuration.php')) //this file should be local
	require_once SERVER_ROOT.$styleFolder.'site-styles-configuration.php'; //is required for unmodified stylesheets to work

if(file_exists(SERVER_ROOT.$styleFolder.'site-styles-configuration2.php')) //this file should be local
	require_once SERVER_ROOT.$styleFolder.'site-styles-configuration2.php'; //is required for unmodified stylesheets to work

\CmsC::_require('styles/normalize.css');
\CmsC::_require('styles/global.css');

//if(!empty($_GET['print']));
  //include SERVER_ROOT.$styleFolder.'site-print.css'; //this file should be local
//else
  \CmsC::_require($styleFolder.'site.css'); //this file should be local

$styles = GET('styles', []); //styles in style folder

foreach($styles as $style)
{
  echo '/*File: '.(\CmsC::getIncludePath($styleFolder.$style.'.css') ? \CmsC::getIncludePath($styleFolder.$style.'.css') : $styleFolder.$style.'.css'. 'NOT FOUND').'*/';
  \CmsC::_include($styleFolder.$style.'.css'); //all these files should be local
  echo PHP_EOL;
}

$stylesAlt = GET('stylesAlt', []); //styles elsewhere on the site

for($i=0, $len=count($stylesAlt); $i<$len; ++$i)
{
  echo '/*File: '.(\CmsC::getIncludePath($stylesAlt[$i]) ? \CmsC::getIncludePath($stylesAlt[$i]) : $stylesAlt[$i]).' NOT FOUND'.'*/';
	\CmsC::_include($stylesAlt[$i]); //preg_replace('/(?:^'.preg_quote(SITE_ROOT).'|\.css$)/', '', $stylesAlt[$i]).'.css';
  echo PHP_EOL;
}

ob_end_flush();
